#include "main.h"
#include <stdio.h>
#include <string.h>

void filerTask(struct sheet *sht)
{
	struct file *file = (struct file *) (DISK_ADDR + 0x00002600);
	struct task *task = taskNow();
	struct filer filer;
	struct timer *timer, *timer2;
	int i, j, dc = -1;
	filer.sht = sht;
	filer.now = -1;
	filer.start = 0;
	filerPrint(&filer);
	timer = timerAlloc();
	timerInit(timer, &task->fifo);
	timerSet(timer, 300, 2);
	timer2 = timerAlloc();
	timerInit(timer2, &task->fifo);

	for (;;) {
		cli();
		if (fifoStat(&task->fifo) == 0) {
			taskSleep(task);
			sti();
		} else {
			i = fifoGet(&task->fifo);
			sti();
			if (i == 1) {
				cli();
				filerExitreq(sht);
				sti();
				for (;;) {
					taskSleep(task);
				}
			} else if (i == 2) {
				filerPrint(&filer);
				timerSet(timer, 300, 2);
			} else if (i == 3) {
				filer.start--;
				if (filer.start < 0) {
					filer.start = 0;
				} else {
					dc = -1;
				}
				timerCancel(timer);
				timerSet(timer, 300, 2);
			} else if (i == 4) {
				filer.start++;
				j = 0;
				for (i = 0; i < 224; i++) {
					if (file[i].name[0] == 0x00) {
						break;
					}
					if (file[i].name[0] != 0xe5) {
						if ((file[i].type & 0x18) == 0) {
							j++;
						}
					}
				}
				if (filer.start > j - 8) {
					filer.start = j - 8;
				} else {
					dc = -1;
				}
				timerCancel(timer);
				timerSet(timer, 300, 2);
			} else if (i == 5) {
				dc = -1;
			} else if (i >= 512) {
				filer.now = i - 512 + filer.start;
				if (filer.now == dc) {
					filerRun(&filer);
					filer.now = -1;
					dc = -1;
					timerCancel(timer2);
				} else {
					dc = filer.now;
					timerCancel(timer2);
					timerSet(timer2, 50, 5);
				}
				timerCancel(timer);
				timerSet(timer, 300, 2);
			}
			filerPrint(&filer);
		}
	}
}

struct sheet *filerOpen(int *fat)
{
	struct memory *mem = (struct memory *) MEMORY_ADDR;
	struct sheet *sht = shtAlloc();
	unsigned char *buf = (unsigned char *) memAlloc(mem, 128 * 165);
	struct task *task = taskAlloc();
	int *fifo = (int *) memAlloc(mem, 128 * 4);
	shtSet(sht, buf, 128, 165, -1);
	winAlloc(sht, "t@C", 0);
	textbox(sht, _FFFFFF, 8, 28, 112, 128);
	task->stack = memAlloc(mem, 64 * 1024);
	task->tss.esp = task->stack + 64 * 1024 - 8;
	task->tss.eip = (int) &filerTask;
	task->tss.es = 1 * 8;
	task->tss.cs = 2 * 8;
	task->tss.ss = 1 * 8;
	task->tss.ds = 1 * 8;
	task->tss.fs = 1 * 8;
	task->tss.gs = 1 * 8;
	*((int *) (task->tss.esp + 4)) = (int) sht;
	fifoInit(&task->fifo, fifo, 128, task);
	task->fat = fat;
	taskRun(task, 2, 2);
	sht->task = task;
	sht->flag |= SHEET_FILER;
	return sht;
}

void filerClose(struct sheet *sht)
{
	extern struct tasks *tctl;
	struct memory *mem = (struct memory *) MEMORY_ADDR;
	struct task *task = sht->task;
	memFree(mem, (int) sht->buf, 128 * 165);
	shtFree(sht);
	taskSleep(task);
	memFree(mem, task->stack, 64 * 1024);
	memFree(mem, (int) task->fifo.buf, 128 * 4);
	cli();
	task->flag = 0;
	if (tctl->tfpu == task) {
		tctl->tfpu = 0;
	}
	sti();
	return;
}

void filerExitreq(struct sheet *sht)
{
	extern struct sheets *shts;
	struct fifo *fifo = (struct fifo *) *((int *) FIFO_ADDR);
	fifoPut(fifo, 2280 + (sht - shts->sheet));
	return;
}

void filerPrint(struct filer *filer)
{
	struct file *file = (struct file *) (DISK_ADDR + 0x00002600);
	int i, j = 0, k = 0, l;
	for (i = 0; i < 8; i++) {
		filer->file[i] = 0;
	}
	for (i = 0; i < 224; i++) {
		if (file[i].name[0] == 0x00) {
			break;
		}
		if (file[i].name[0] != 0xe5) {
			if ((file[i].type & 0x18) == 0) {
				if (j == filer->start) {
					break;
				}
				j++;
			}
		}
	}
	for (j = 0; i < 224; i++) {
		if (file[i].name[0] == 0x00) {
			break;
		}
		if (file[i].name[0] != 0xe5) {
			if ((file[i].type & 0x18) == 0) {
				filer->file[j] = &file[i];
				j++;
				if (j >= 8) {
					break;
				}
			}
		}
	}
	for (i = 0; i < 224; i++) {
		if (file[i].name[0] == 0x00) {
			break;
		}
		if (file[i].name[0] != 0xe5) {
			if ((file[i].type & 0x18) == 0) {
				k++;
			}
		}
	}
	filerPlist(filer);
	graphicBox(filer->sht, _C6C6C6, filer->sht->sx - 21, 27, filer->sht->sx - 8, filer->sht->sy - 9);
	graphicButton(filer->sht, filer->sht->sx - 20, 27, 12, 20, "\36", 0);
	graphicButton(filer->sht, filer->sht->sx - 20, filer->sht->sy - 29, 12, 20, "\37", 0);
	l = (filer->sht->sy - 48 - 29) * j / k;
	i = 48 + (filer->sht->sy - 48 - 29 - l) / (k - j) * filer->start;
	graphicButton(filer->sht, filer->sht->sx - 20, i, 12, l - 1, "", 0);
	shtRefresh(filer->sht, 8, 27, 121, 157);
	return;
}

void filerPlist(struct filer *filer)
{
	char s[13];
	int i, j;
	s[12] = 0;
	for (i = 0; i < 8; i++) {
		if (filer->file[i] == 0) {
			break;
		}
		for (j = 0; j < 8; j++) {
			s[j] = filer->file[i]->name[j];
		}
		s[9] = filer->file[i]->ext[0];
		s[10] = filer->file[i]->ext[1];
		s[11] = filer->file[i]->ext[2];
		if (filer->file[i]->ext[0] == ' ') {
			s[8] = ' ';
		} else {
			s[8] = '.';
		}
		if (filer->now - filer->start != i) {
			graphicBox(filer->sht, _FFFFFF, 8, 28 + i * 16, filer->sht->sx - 23, 28 + i * 16 + 16);
			graphicPuts(filer->sht, _000000, 8, 28 + i * 16, s);
		} else {
			graphicBox(filer->sht, _000084, 8, 28 + i * 16, filer->sht->sx - 23, 28 + i * 16 + 16);
			graphicPuts(filer->sht, _FFFFFF, 8, 28 + i * 16, s);
		}
	}
	return;
}

void filerRun(struct filer *filer)
{
	static char *bind[4 * 2] = {
		"HRB", "%s",
		"BMP", "iview %s",
		"JPG", "iview %s",
		"MML", "mplay %s"
	};
	struct task *task = taskNow();
	char s[31], name[13];
	int i, j;
	for (i = 0; i < 31; i++) {
		s[i] = 0;
	}
	filerMakename(filer, name);
	for (j = 0; name[j] != 0; j++) {
		if (name[j] == '.') {
			break;
		}
	}
	for (i = 0; i < 4; i++) {
		if (strncmp(bind[i * 2], name + j + 1, 3) == 0) {
			sprintf(s, bind[i * 2 + 1], name);
			break;
		}
	}
	if (i == 4) {
		sprintf(s, "memo %s", name);
	}
	consNcst(s, task->fat);
	return;
}

void filerMakename(struct filer *filer, char *name)
{
	struct file *file = filer->file[filer->now - filer->start];
	int i, j = 0;
	for (i = 0; i < 13; i++) {
		name[i] = 0;
	}
	for (i = 0; i < 12; i++) {
		if (&file->name[i] == &file->ext[0] && 0 < j && name[j - 1] != '.') {
			name[j] = '.';
			j++;
			i--;
		} else if (file->name[i] != ' ') {
			name[j] = file->name[i];
			j++;
		}
	}
	return;
}
